#!/usr/bin/python
import sys
import ujson
import os


HTTP_GET = 'GET'
HTTP_PUT = 'PUT'
HTTP_POST = 'POST'
HTTP_DELETE = 'DELETE'


def response_fail(http_code):
    jnode = {
        'errors': [],
        'status': http_code
    }

    return jnode


def response_success(result_jnode):
    jnode = {
        'result': result_jnode,
        'status': 200
    }

    return jnode


def run(http_method):
    if http_method == HTTP_PUT:
        response_jnode = response_success([])
        print ujson.dumps(dict(response_jnode))
        os.system("shutdown -r now > /dev/null 2>&1")

    else:
        response_jnode = response_fail(405)
        print ujson.dumps(dict(response_jnode))


if __name__ == '__main__':
    http_mode = os.environ['REQUEST_METHOD']
    run(http_mode)
    sys.exit(0)

